#define PORTNUM 99
#define CLISIZE 50 
#define MAXNAMELEN 20
#define CMDLEN 20
#define STALETIME 120 
#define MAXGROUPSIZE 500
#define CFLINELENGTH 4096
#define MAXNUMCLIENTS 500
#define MAXMSGSIZE 1024
#define VEGPOPID "VP1"
#define TALKCF "vegpop.cf"



/*
	Clients exist as a linked list of client_t.
	Groups consist of linked lists of group members (gmem_t)s each of
	each of which refer to a client.
	A Groupset is a linked list of groups.
*/	


typedef struct vpmsg {
	char vegpopid[3];
	char type;
	char trnid[2];
	char fromnick[20];
	char tonick[20];
	char auth[30];
    char data[MAXMSGSIZE];
} vpmsg_t;



typedef struct vpmsglist {
	vpmsg_t *vpmsg;
	char date[30];
	struct sockaddr_in fromhost;
	struct vpmsglist *next;
	struct vpmsglist *last;
} vpmsglist_t;



typedef struct client {
	char clientname[MAXNAMELEN];
   	char status;
   	struct sockaddr_in cliaddr;
   	time_t t;
   	struct client *next_c;
} client_t;




typedef struct gmem {
	char clientname[MAXNAMELEN];
	struct gmem *next_gm;
} gmem_t;




typedef struct pgroup {
	char grname[20];
	gmem_t *bar;
	gmem_t *active;
	struct pgroup *next_pg;
} pgroup_t;		


void leave(char *message);
void init_conf(pgroup_t **,client_t **);
pgroup_t *new_pgroup(pgroup_t **topg,char *newname);
pgroup_t *find_group(pgroup_t *top,char *gname);
client_t *find_client(client_t *cl,char *cliname);
pgroup_t *find_group(pgroup_t *gp,char *grname);

#define SIZE_VPMSGHDR (sizeof(struct vpmsg)-MAXMSGSIZE)
